package worker

import (
	"git.pbiernat.dev/egommerce/catalog-service/internal/service"
)

var (
	StockUpdated = "event.WarehouseStockUpdatedEvent"
)

type Command interface {
	run(CommandData) (bool, any)
}

type CommandData map[string]interface{}

type CommandRunner struct {
	cmd Command
}

func (r *CommandRunner) run(data CommandData) (bool, any) {
	return r.cmd.run(data)
}

type StockUpdatedCommand struct {
	srvc *service.CatalogService
}

func (c *StockUpdatedCommand) run(data CommandData) (bool, any) {
	// reqID := data["request_id"].(string)           // FIXME Check input params!
	// productID := int(data["product_id"].(float64)) // FIXME Check input params!

	// stock, err := ui.StockUpdated(c.srvc, productID, reqID)
	return true, nil //err == nil, basket
}
